﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import net.richardlord.utils.MathUtils;
	import com.actionscriptfacile.ui.text.UITextField;
	import com.as3facile.DefaultButton;

	import flash.events.MouseEvent;
	
	import com.demonsters.debugger.MonsterDebugger;
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	
	
	// definit la couleur de fond du swf
	[SWF(backgroundColor="0xffffff")] 

	public class Main extends Sprite
	{

		private var nSecondes : uint;					// chiffre alétoire pour le nombre de secondes
		private var oValSecondes : UITextField;			// texte avec les secondes
		private var oValhms : UITextField;				// texte avec la conversion type YouTube H:min:s
		

		/**
		 * Constructeur.
		 * 
		 * Compiler avec le SDK Flex 4.6
		 * 
		 * -swf-version = 18 : pour l'API Flash Player 11.5
		 * -default-frame-rate 40 : nombre d'images par secondes
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * 
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start conversion");
			
			this.buildUI();
		}


		/**
		 * Construit l'affichage de l'application.
		 * 
		 * 
		 */
		private function buildUI() : void
		{ 	
			// un nombre aléatoire pour les secondes
			nSecondes = MathUtils.randomInt(1, 13000);// plus d'infos sur http://www.actionscript-facile.com/classe-utilitaire-math-nombre-aleatoire-conversion-degres-radians/article1223303.html
			
			oValSecondes = this.addText("Prochaine valeur à convertir : "+nSecondes.toString()+" secondes.");
			oValSecondes.x = 20;
			oValSecondes.y = 69;
			this.addChild(oValSecondes);
			
			oValhms = this.addText("Cliquez sur le bouton 'conversion'.");
			oValhms.x = oValSecondes.x;
			oValhms.y = oValSecondes.y + 31;
			this.addChild(oValhms);
			
			// Création du bouton conversion
			var oBtnConvert:DefaultButton = new DefaultButton();
			oBtnConvert.getObject().label = "Conversion";
			oBtnConvert.getObject().x = (stage.stageWidth - oBtnConvert.getObject().width) / 2;
			oBtnConvert.getObject().y = 250;
			oBtnConvert.getObject().addEventListener ( MouseEvent.CLICK, onConvertSecondes );
			this.addChild(oBtnConvert);
		}


		/**
		 * Appel lors du clique sur le bouton
		 */
		private function onConvertSecondes(event : MouseEvent) : void
		{
			// appel la fonction de conversion
			var sHminSeconds:String = secondsToMinutes(nSecondes);
			
			oValhms.text = nSecondes.toString()+" secondes donnent "+sHminSeconds;
			
			
			// un nouveau nombre aléatoire en secondes pour la prochaine conversion
			nSecondes = MathUtils.randomInt(1, 13000);
			oValSecondes.text = "Prochaine valeur à convertir : "+nSecondes.toString()+" secondes.";
		}


		/**
		 * Conversion des secondes en minutes - exemple : 153 secondes en 02:33
		 * 
		 * @param nSeconds : nombre de secondes
		 * @return : une chaine de caractère au format 00:00
		 */
		private function secondsToMinutes( nSeconds:uint) : String
		{
			var sTime:String;

			// si la durée est supérieure à 1h00
			if ( nSeconds >= 60 * 60 )
			{
				// Format -> H:MM:SS
				sTime = (Math.floor(nSeconds / (60 * 60))) + // Heures 
				":" + ("0" + Math.floor((nSeconds % (60 * 60)) / 60)).substr(-2) + // Minutes 
				":" + ("0" + (nSeconds % 60)).substr(-2);// Secondes
			}
			else
			{
				// Format -> MM:SS
				sTime = ("0" + Math.floor(nSeconds / 60)).substr(-2) + // Minutes 
				":" + ("0" + (nSeconds % 60)).substr(-2);// Secondes
			}
			return sTime;
		}
		
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("size", 25);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			
			return oTxtField;	 
		}		

	}
}
